class StubHud extends Mutator;

var HudPRI RootPRI, CurrPRI;
var Font FirstFont;

simulated function Tick(float DeltaTime) {
	if (Level.NetMode != NM_DedicatedServer) {
		if (!bHUDMutator) RegisterHUDMutator();
	}
	if (Level.NetMode != NM_Client) {
		// do something on server
		if (RootPRI == None) {
			// init stuff - called only once
			setTimer(1, true);
		};
		
		GetRoot();
	}
}

function Timer() {
	GetRoot().UpdateAll();
}

simulated function PostRender(canvas C) {
	local HudPRI curr;
	
    if (NextHUDMutator != None)
        NextHUDMutator.PostRender(C);
        
	curr = GetCurr(C.Viewport.Actor);
	if (curr != None) {
		C.SetPos(0, C.ClipY/2);
		if (FirstFont == None) {
			FirstFont = class'FontInfo'.Static.GetStaticSmallFont(C.ClipX);
		} else if (FirstFont != C.Font) {
			C.Font = FirstFont;
		}
		C.DrawColor.R = 255;
		C.DrawColor.G = 255;
		C.DrawColor.B = 255;
		
		// Draw text here
		C.DrawText("StubHud: " $ curr.foo);
	}
}

function HudPRI GetRoot() {
	local HudPRI curr;
	
	if (RootPRI == None) {
		RootPRI = Spawn(class'HudPRI', Self);
	}
	return RootPRI;
}

function ModifyPlayer(Pawn Player) {
	if (Level.NetMode != NM_Client && Player != None && Player.isA('PlayerPawn')) {
		GetRoot().Get(PlayerPawn(Player).PlayerReplicationInfo);
	}
}

simulated function HudPRI GetCurr(PlayerPawn Player) {
	local HudPRI curr;

	if (CurrPRI == None) {
		foreach AllActors(Class'HudPRI', curr) {
			if (curr.OwnerPRI == Player.PlayerReplicationInfo) {
				CurrPRI = curr;
				break;
			}
		}
	}
	return CurrPRI;
}

defaultproperties {
	bAlwaysRelevant=True
	bNetTemporary=True
	RemoteRole=ROLE_SimulatedProxy
}